//	CurvedSpacesOptions.c
//
//	© 2009 by Jeff Weeks
//	See TermsOfUse.txt

#include "CurvedSpaces-Common.h"


void SetSceneryType(
	ModelData	*md,
	SceneryType	aSceneryTypeChoice)
{
	md->itsSceneryType			= aSceneryTypeChoice;
	md->itsPreparedVBOs			= false;
	md->itsRedrawRequestFlag	= true;
}

void SetShowObserver(
	ModelData	*md,
	bool		aShowObserverChoice)
{
	md->itsShowObserver			= aShowObserverChoice;
	md->itsPreparedVBOs			= false;
	md->itsRedrawRequestFlag	= true;
}

void SetShowColorCoding(
	ModelData	*md,
	bool		aShowColorCodingChoice)
{
	md->itsShowColorCoding		= aShowColorCodingChoice;
	md->itsPreparedVBOs			= false;
	md->itsRedrawRequestFlag	= true;
}

void SetShowCliffordParallels(
	ModelData	*md,
	bool		aShowCliffordParallelsChoice)
{
	md->itsShowCliffordParallels	= aShowCliffordParallelsChoice;
	md->itsPreparedVBOs				= false;
	md->itsRedrawRequestFlag		= true;
}

void SetShowVertexFigures(
	ModelData	*md,
	bool		aShowVertexFiguresChoice)
{
	md->itsShowVertexFigures	= aShowVertexFiguresChoice;
	md->itsPreparedVBOs			= false;
	md->itsRedrawRequestFlag	= true;
}

void SetFogFlag(
	ModelData	*md,
	bool		aFogFlag)
{
	md->itsFogFlag = aFogFlag;
}

void SetMultisamplingEnabledFlag(
	ModelData	*md,
	bool		aMultisamplingEnabledFlag)
{
	//	The platform-dependent code will replace the old OpenGL context with a new one.
	//	Here we merely set and save the platform-independent code's flag.
	
	md->itsMultisamplingEnabledFlag	= aMultisamplingEnabledFlag;
	md->itsRedrawRequestFlag		= true;

	SetUserPref("multisampling", aMultisamplingEnabledFlag);
}

void SetStereo3DFlag(
	ModelData	*md,
	bool		aStereo3DFlag)
{
	md->itsStereoFlag			= aStereo3DFlag;
	md->itsPreparedTextures		= false;
	md->itsPreparedVBOs			= false;
	md->itsRedrawRequestFlag	= true;
}

void SetAnisotropicEnabledFlag(
	ModelData	*md,
	bool		anAnisotropicEnabledFlag)
{
	md->itsAnisotropicEnabledFlag	= anAnisotropicEnabledFlag;
	md->itsPreparedTextures			= false;
	md->itsRedrawRequestFlag		= true;
}

void SetShadersEnabledFlag(
	ModelData	*md,
	bool		aShadersEnabledFlag)
{
	md->itsShadersEnabledFlag	= aShadersEnabledFlag;
	md->itsPreparedShaders		= false;
	md->itsRedrawRequestFlag	= true;

	SetUserPref("shaders", aShadersEnabledFlag);
}
