uniform float	uniFogFactor,			//	0.0 = off;  1.0 = on
				uniFogRangeParameter;	//	Euclidean interpretation:  inverse square of distance at which fog saturates

attribute mat4	atrModelViewProjectionMatrix,
				atrModelViewMatrix;
attribute vec4	atrPosition;
attribute vec2	atrTextureCoordinates;
attribute vec4	atrColor;

varying vec2	varTextureCoordinates;
varying vec4	varColor;


void main()
{
	vec3	tmpPositionEC;	//	vertex's position in eye coordinates
	float	tmpFogValue;	//	0.0 = bright;  1.0 = dark
	
	gl_Position				= atrModelViewProjectionMatrix * atrPosition;
	varTextureCoordinates	= atrTextureCoordinates;
	tmpPositionEC			= vec3(atrModelViewMatrix * atrPosition);
	tmpFogValue				= min(uniFogRangeParameter * dot(tmpPositionEC, tmpPositionEC), 1.0);
	varColor				= (1.0 - uniFogFactor*tmpFogValue) * atrColor;
}
